Bug 428801 - [Areca 4.7 feat] Update the arcmsr driver to
[Areca 4.7 feat] Update the arcmsr driver to
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
All Linux
high Severity high
: rc
: ---
Assigned To: Tomas Henzl
: FutureFeature, OtherQA
Depends On:
Blocks: 262141 RHEL4u7_relnotes
  Show dependency treegraph
Reported: 2008-01-15 06:14 EST by nickcheng
Modified: 2009-06-19 22:05 EDT (History)
6 users (show)

See Also:
Fixed In Version: RHSA-2008-0665
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2008-07-24 15:24:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
The patch for Areca driver, arcmsr, against RHEL4.7 (23.77 KB, application/zip)
2008-01-15 06:14 EST, nickcheng
no flags Details
Update the patch for arcmsr (108.37 KB, patch)
2008-02-12 23:27 EST, Nick Cheng
no flags Details | Diff
Update the patch for arcmsr (108.37 KB, patch)
2008-02-12 23:27 EST, Nick Cheng
no flags Details | Diff
arcmsr_hba.c (47.93 KB, patch)
2008-02-25 06:06 EST, Tomas Henzl
no flags Details | Diff
areca files (60.71 KB, application/octet-stream)
2008-02-28 04:41 EST, Tomas Henzl
no flags Details
The patch for arcmsr- (39.48 KB, patch)
2008-03-03 21:48 EST, Nick Cheng
no flags Details | Diff
patch for Kconfig (1.13 KB, patch)
2008-03-05 21:28 EST, Nick Cheng
no flags Details | Diff
new version (155.05 KB, patch)
2008-03-12 10:01 EDT, Tomas Henzl
no flags Details | Diff
Change Log for arcmsr (6.83 KB, text/plain)
2008-06-02 22:49 EDT, Nick Cheng
no flags Details

  None (edit)
Description nickcheng 2008-01-15 06:14:44 EST
Description of problem:

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
Actual results:

Expected results:

Additional info:
Comment 1 nickcheng 2008-01-15 06:14:44 EST
Created attachment 291703 [details]
The patch for Areca driver, arcmsr, against RHEL4.7
Comment 2 RHEL Product and Program Management 2008-01-15 06:27:25 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
Comment 4 Tomas Henzl 2008-02-06 07:44:16 EST
you patchfiles are probably generated against RHEL5.1, they are failing in this
case. I'm going to send to you the sources from 4.6. Please recreate/backport
the pathset. RHEL4 is based on kernel 2.6.9.
Comment 7 Tomas Henzl 2008-02-06 08:32:29 EST
Nick, you could also use the sources from  bz#233399
Thanks for your time
Comment 8 Nick Cheng 2008-02-12 23:27:25 EST
Created attachment 294727 [details]
Update the patch for arcmsr
Comment 9 Nick Cheng 2008-02-12 23:27:49 EST
Created attachment 294728 [details]
Update the patch for arcmsr
Comment 10 Tomas Henzl 2008-02-15 09:20:36 EST
Nick, again this patch fails to apply against current RHEL4.6 code base. For
example this doesn't work because there function arcmsr_adjust_disk_queue_depth
is not part of arcmsr_hba.c.
-static int arcmsr_adjust_disk_queue_depth(struct scsi_device *sdev, int
+static ssize_t arcmsr_adjust_disk_queue_depth(struct device *dev, const char
*buf, size_t count)
Or I'm doing something wrong ?
Try to use code base from https://bugzilla.redhat.com/show_bug.cgi?id=233399
From Comment 29 in233399 http://people.redhat.com/~jbaron/rhel4/
Comment 11 Nick Cheng 2008-02-17 20:57:31 EST
OK, I will check.
Comment 12 Nick Cheng 2008-02-19 01:01:40 EST
Would you please check if the arcmsr source code version is
If it is, arcmsr_adjust_disk_queue_depth() should be there.
The kernel is 2.6.9-67.ELsmp of RHEL4.6 GA on my site.
Is it synchronous to yours?
Comment 13 Tomas Henzl 2008-02-25 06:06:59 EST
Created attachment 295784 [details]

sorry for being late, I was on vacation last week.
It is "Driver Version", but the symbol
arcmsr_adjust_disk_queue_depth is not there as you can see in the attachment.
Comment 14 Tomas Henzl 2008-02-27 11:56:58 EST
do you need some other help from me ?
Comment 15 Nick Cheng 2008-02-28 00:53:14 EST
Hi Tomas,
I check the patch that I made for RHEL4.6 and found it really lacks
It just came to my mind that I made a few changes on arcmsr-  to fit
But I don't keep the variant of source code that I ported for RHEL4.6.
I should be blamed.
Sorry to bother you.
Would you please kindly send me the (1)arcmsr_hba.c, (2)arcmsr_attr.c,
(3)arcmsr.h, (4)pci_ids.h, (5)ChangeLog.arcmsr and (6)Kconfig in
Comment 16 Tomas Henzl 2008-02-28 04:41:36 EST
Created attachment 296175 [details]
areca files

Nick, I attached the files here, note that there is not Changelog.arcmsr in the
current codebase. Other way how to get the sources is mentioned in Comments
Comment 17 Nick Cheng 2008-03-03 21:48:02 EST
Created attachment 296695 [details]
The patch for arcmsr-

This is the patch for arcmsr- @ RHEL4 Update 7
Comment 18 Tomas Henzl 2008-03-04 09:00:02 EST
Nick, it looks like, that in the Kconfig part of your patch, you are changing
things that do not belong to the arcmsr driver. Please could you clarify this ? 
Comment 19 Nick Cheng 2008-03-05 21:28:44 EST
Created attachment 296981 [details]
patch for Kconfig

Would you please check if this answers your need?
If not, please let me know.
Comment 20 Tomas Henzl 2008-03-06 11:57:50 EST
Nick, thanks it looks good.

+** For history of changes, see Documentation/scsi/ChangeLog.arcmsr
+**     Firmware Specification, see Documentation/scsi/arcmsr_spec.txt
The patches for these files are missing, it looks like you are moving the
firmware spec from arcmsr.h to arcmsr_spec.txt, so could you provide a patch for
that(also for ChangeLog.arcmsr) ?
-		arcmsr_interrupt(acb);
+		arcmsr_interrupt(acb);/* FIXME: need spinlock */
what does this change mean, shouldn't it rather be fixed ?

Comment 21 Tomas Henzl 2008-03-09 13:01:59 EDT
Nick, you are removing in the function void arcmsr_polling_ccbdone the line :
- poll_ccb_done = 1;
The upstream version does not remove this, so it is only a lapse or is there a
reason for it ?
Comment 22 Nick Cheng 2008-03-09 22:24:40 EDT
Hi Tomas,
For the comment #20, just for sure, do you really need the ChangeLog.arcmsr?
You mentioned there is no ChangeLog.arcmsr for the code base in Comment#16.

If you really need it, I will make a patch for you.
As for  -arcmsr_interrupt(acb);
        +arcmsr_interrupt(acb);/* FIXME: need spinlock */
this is from kernel.org comment, it is for the notification purpose.
It is still an open issue, although I think it has no need to do a fix.
But just let it be there, maybe someone could have other special comments.

For the comment #21, I check it on my site and find it has been removed the 
line, poll_ccb_done = 1.
It could be staying in -mm stage.

Comment 23 Tomas Henzl 2008-03-10 05:27:48 EDT
Hi Nick, 
I created the arcmsr_spec.txt from upstream and I agree with you that the
Changelog is not so important.

Last open issue which I don't understand yet is the "poll_ccb_done = 1".
Should the line stay in the sources or not? I think we will better use the
upstream version - what do you think ?
Comment 24 Nick Cheng 2008-03-10 06:30:53 EDT
After my last review, I found it will be logical if there is no "poll_ccb_done 
= 1".
I have upstreamed to kernel.org with a version w/o poll_ccb_done = 1.
I agree with you'r idea.
But I think it will be adopted into kernel source sooner or later.
If you persist in your opinion, I will submit to it.
BTW, should I make a patch for arcmsr_spec.txt?
Comment 25 Tomas Henzl 2008-03-10 07:35:17 EDT
Nick, thanks, the patch for arcmsr_spec.txt is not needed as I created it myself.

>I have upstreamed to kernel.org with a version w/o poll_ccb_done = 1.
Could you point me where you upstreamed it ? I mean on which list + date.

Comment 27 Tomas Henzl 2008-03-12 10:01:38 EDT
Created attachment 297765 [details]
new version

Nick, this is the version we were talking about. Please check it if it is OK.
Comment 28 Vivek Goyal 2008-03-27 19:23:24 EDT
Committed in 68.27.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/
Comment 30 Nick Cheng 2008-05-12 00:37:32 EDT
Hi Tomas,
Sorry, I paid no attention to this message.
Do you still waiting my response?
Comment 31 Tomas Henzl 2008-05-12 04:05:08 EDT
don't know what message, but now is important the message from Comment #28,
please download and test the new kernel.
Comment 32 nickcheng 2008-05-19 06:38:05 EDT
I can't boot the kernel.
Comment 33 Tomas Henzl 2008-05-19 07:01:24 EDT
I'm going to test it, but could you more precisely say what kernel you couldn't
boot and if any, some error messages ?
Btw. this a kernel for RHEL4.7.

Comment 34 nickcheng 2008-05-19 07:20:38 EDT
I download kernel-2.6.9-70.EL.src.rpm and kernel-2.6.9-70.EL.x86_64.rpm and
build the kernel. But after I reboot the built kernel, I got kernel panic.
It has nothing to do with Areca driver because I don't have Areca RAID card on it. 
Comment 35 Tomas Henzl 2008-05-19 07:47:49 EDT
The kernel-2.6.9-70.EL.x86_64.rpm is already a package with a built kernel. I've
just tried to install it with rpm ('rpm -ivh kernel-2.6.9-70.EL.i686.rpm') and
it works. Does it work when you install it directly without compiling ?
Comment 36 Don Domingo 2008-05-20 23:54:40 EDT
this bug has been tagged for inclusion in RHEL4.7 release notes. please provide
a short summary of changes applied in this update to the arcmsr driver. thanks!
Comment 37 nickcheng 2008-05-21 03:11:18 EDT
What kind of update to arcmsr?
I have no idea what are you talking about.
Comment 38 Tomas Henzl 2008-05-21 05:22:12 EDT
'release notes' is a text which describes what is new in RHEL4.7.
So we should write down what is new in this driver - for example

- driver updated to version to This update applies several
changes, most notably:
   * Support for new controllers - ARC1200/1201/1202 SATA RAID adapter
   * Many bugfixes and minor improvements

If you are aware of something more precise then 'Many bugfixes and minor
improvements' then please advise.

Comment 39 Don Domingo 2008-05-21 18:36:49 EDT
Thanks Tomas. adding to RHEl4.7 release notes under "Driver Updates => Storage":

arcmsr: driver updated to version This update applies several bug
fixes and minor enhancements; in addition, it also provides support for the
following SATA RAID adapters:

    * ARC1200
    * ARC1201
    * ARC1202

please advise if any further revisions are required. thanks!
Comment 40 nickcheng 2008-05-23 04:44:31 EDT
Would you please check the arcmsr version in arcmsr.h by searching
Thank you,
Comment 43 Tomas Henzl 2008-05-27 05:54:45 EDT
sorry I haven't noticed your question(Comment #40). The version from the latest
attachment is 
+#define ARCMSR_DRIVER_VERSION	"Driver Version 2008/02/27"
Comment 44 Nick Cheng 2008-05-29 02:54:44 EDT
Hi Tomas,
Sorry to late response.
If the driver in RHEL4U7 is "Driver Version 2008/02/27", it is
not the first version that includes the ARC120X HBAs.
I am afraid you get wrong or I misconstrue you.
Would you mind to kindly check it out?
Comment 45 Tomas Henzl 2008-05-29 04:53:42 EDT
from the latest attachment
+#define PCI_DEVICE_ID_ARECA_1200	0x1200
+#define PCI_DEVICE_ID_ARECA_1201	0x1201
+#define PCI_DEVICE_ID_ARECA_1202	0x1202
this looks like a support for a new hardware, please check it.

Is there anything else what you think should be mentioned in the release notes ?

Comment 46 Don Domingo 2008-06-02 19:17:46 EDT

the RHEL4.7 release notes deadline is on June 17, 2008 (Tuesday). they will
undergo a final proofread before being dropped to translation, at which point no
further additions or revisions will be entertained.

a mockup of the RHEL4.7 release notes can be viewed here:

please use the aforementioned link to verify if your bugzilla is already in the
release notes (if it needs to be). each item in the release notes contains a
link to its original bug; as such, you can search through the release notes by
bug number.

Comment 47 Nick Cheng 2008-06-02 22:00:41 EDT
The hyperlink,
http://intranet.corp.redhat.com/ic/intranet/RHEL4u7relnotesmockup.html, is not
Comment 48 Don Domingo 2008-06-02 22:24:23 EDT
Hi Nick,
sorry, that page is only available internally to RHEL people. anyhow, the
release note for this item is quoted in Comment#39
Comment 49 Nick Cheng 2008-06-02 22:49:21 EDT
Created attachment 308180 [details]
Change Log for arcmsr
Comment 50 Chris Ward 2008-06-05 11:57:27 EDT
~ Attention: ~ Feedback requested regarding this **High Priority** bug. 

A fix for this issue should be included in the latest packages contained in
RHEL4.7-Snapshot1--available now on partners.redhat.com.

After you (Red Hat Partner) have verified that this issue has been addressed,
submit a comment describing the passing results of your test in appropriate
detail, along with which snapshot and package version tested. The bugzilla will
be updated by Red Hat Quality Engineering for you when this information has been

If you believe this issue has not properly fixed or you are unable to verify the
issue for any reason, please add a comment describing the most recent issues you
are experiencing, along with which snapshot and package version tested. 

If you believe the bug has not been fixed, change the status of the bug to ASSIGNED.

If you are receiving this message in Issue Tracker, please reply with a message
to Issue Tracker about your results and bugzilla will be updated for you. 

If you need assistance accessing ftp://partners.redhat.com, please contact your
Partner Manager.

Thank you
Red Hat QE Partner Management
Comment 51 Nick Cheng 2008-06-05 21:47:25 EDT
Could we close this bug report?
Comment 52 Don Domingo 2008-06-05 21:59:15 EDT
i believe that's up to QE. i only do the documentation for specific bugs. :-) 
Comment 53 Chris Ward 2008-06-06 04:24:59 EDT
Nick, have you been able to successfully verify the bug in either the 4.7 Beta
or Snapshot 1? If your latest findings indicate the bug has been addressed, QE
will be glad to close this bug report for you.
Comment 54 Nick Cheng 2008-06-06 04:44:56 EDT
Actually this is not a really bug.
It starts to request adding Areca driver into RHEL4U7.
Now, it seems so far so good.
How do I close this bug?
Comment 57 Chris Ward 2008-06-06 05:32:51 EDT
Nick, since there will be changes made to the kernel source to update the arcmsr
driver, we must *verify* that these changes have been made correctly. 

Since you reported the request, it would be great if you could test and verify
that this driver update has actually been properly included in the latest kernel
available in the RHEL 4.7 Beta or Snapshot 1 and meets your expectations.

Let me know which version of the kernel you tested. The latest RHEL4.7 snapshot
is available on http://partners.redhat.com

Additional information can be found in Comment #50. 

Comment 58 Andrius Benokraitis 2008-06-06 10:11:10 EDT
Nick, this bugzilla must say open until the product GAs... since you've tested
and verified the features update to the arcmsr driver, I'm going to change it to
VERIFIED. No other action is needed from you at this point, unless anything is
of issue to the submission.
Comment 61 Nick Cheng 2008-06-11 23:21:37 EDT
Hi Andrius,
I verified it on RHEL 4.7 Snapshot 1.
So far so good.
Comment 62 Andrius Benokraitis 2008-06-12 00:36:04 EDT
Great, thanks for the update Nick!
Comment 64 errata-xmlrpc 2008-07-24 15:24:35 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

Comment 65 Chris Ward 2008-07-29 03:28:42 EDT
Partners, I would like to thank you all for your participation in assuring the
quality of this RHEL 4.7 Update Release. My hat's off to you all. Thanks.

Note You need to log in before you can comment on or make changes to this bug.